"""
    WhyLabs API client

    WhyLabs API that enables end-to-end AI observability  # noqa: E501

    The version of the OpenAPI document: 0.1
    Contact: support@whylabs.ai
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from whylabs_client.api_client import ApiClient, Endpoint as _Endpoint
from whylabs_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from whylabs_client.model.get_asset_response import GetAssetResponse
from whylabs_client.model.list_assets_response import ListAssetsResponse
from whylabs_client.model.upload_asset_request import UploadAssetRequest
from whylabs_client.model.upload_asset_response import UploadAssetResponse


class AssetsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.get_asset_endpoint = _Endpoint(
            settings={
                'response_type': (GetAssetResponse,),
                'auth': [
                    'ApiKeyAuth'
                ],
                'endpoint_path': '/v1/assets/{asset_id}/',
                'operation_id': 'get_asset',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'asset_id',
                    'tag',
                    'version',
                    'shared',
                ],
                'required': [
                    'asset_id',
                    'tag',
                ],
                'nullable': [
                    'version',
                    'shared',
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'asset_id':
                        (str,),
                    'tag':
                        (str,),
                    'version':
                        (int, none_type,),
                    'shared':
                        (bool, none_type,),
                },
                'attribute_map': {
                    'asset_id': 'asset_id',
                    'tag': 'tag',
                    'version': 'version',
                    'shared': 'shared',
                },
                'location_map': {
                    'asset_id': 'path',
                    'tag': 'query',
                    'version': 'query',
                    'shared': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.list_organization_assets_endpoint = _Endpoint(
            settings={
                'response_type': (ListAssetsResponse,),
                'auth': [
                    'ApiKeyAuth'
                ],
                'endpoint_path': '/v1/assets/list',
                'operation_id': 'list_organization_assets',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'limit',
                    'shared',
                ],
                'required': [],
                'nullable': [
                    'limit',
                    'shared',
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'limit':
                        (int, none_type,),
                    'shared':
                        (bool, none_type,),
                },
                'attribute_map': {
                    'limit': 'limit',
                    'shared': 'shared',
                },
                'location_map': {
                    'limit': 'query',
                    'shared': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.upload_asset_endpoint = _Endpoint(
            settings={
                'response_type': (UploadAssetResponse,),
                'auth': [
                    'ApiKeyAuth'
                ],
                'endpoint_path': '/v1/assets/{asset_id}/upload',
                'operation_id': 'upload_asset',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'asset_id',
                    'tag',
                    'upload_asset_request',
                    'filename',
                ],
                'required': [
                    'asset_id',
                    'tag',
                    'upload_asset_request',
                ],
                'nullable': [
                    'filename',
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'asset_id':
                        (str,),
                    'tag':
                        (str,),
                    'upload_asset_request':
                        (UploadAssetRequest,),
                    'filename':
                        (str, none_type,),
                },
                'attribute_map': {
                    'asset_id': 'asset_id',
                    'tag': 'tag',
                    'filename': 'filename',
                },
                'location_map': {
                    'asset_id': 'path',
                    'tag': 'query',
                    'upload_asset_request': 'body',
                    'filename': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json',
                    'application/octet-stream'
                ]
            },
            api_client=api_client
        )

    def get_asset(
        self,
        asset_id,
        tag,
        **kwargs
    ):
        """Endpoint to retrieve assets  # noqa: E501

        Endpoint to retrieve assets  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_asset(asset_id, tag, async_req=True)
        >>> result = thread.get()

        Args:
            asset_id (str):
            tag (str):

        Keyword Args:
            version (int, none_type): [optional]
            shared (bool, none_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            GetAssetResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['asset_id'] = \
            asset_id
        kwargs['tag'] = \
            tag
        return self.get_asset_endpoint.call_with_http_info(**kwargs)

    def list_organization_assets(
        self,
        **kwargs
    ):
        """Endpoint to list assets for an organization  # noqa: E501

        Endpoint to list assets for an organization  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_organization_assets(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            limit (int, none_type): [optional]
            shared (bool, none_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            ListAssetsResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.list_organization_assets_endpoint.call_with_http_info(**kwargs)

    def upload_asset(
        self,
        asset_id,
        tag,
        upload_asset_request,
        **kwargs
    ):
        """Endpoint to upload an asset  # noqa: E501

        Endpoint to upload an asset  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.upload_asset(asset_id, tag, upload_asset_request, async_req=True)
        >>> result = thread.get()

        Args:
            asset_id (str):
            tag (str):
            upload_asset_request (UploadAssetRequest):

        Keyword Args:
            filename (str, none_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            UploadAssetResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['asset_id'] = \
            asset_id
        kwargs['tag'] = \
            tag
        kwargs['upload_asset_request'] = \
            upload_asset_request
        return self.upload_asset_endpoint.call_with_http_info(**kwargs)

